  Program
! ***************************************************************************************
! *     Copyright 2006, by George R. Curtis <grcurtis@go.com>. All rights reserved.    *
! ***************************************************************************************
! *   Redistribution and use in source and binary forms, with or without modification,  *
! *   are permitted provided that the following conditions are met:                     *
! *                                                                                     *
! *       1. Redistributions of source code must retain the above copyright             *
! *          notice, this list of conditions and the following disclaimer.              *
! *                                                                                     *
! *       2. Redistributions in binary form must reproduce the above copyright          *
! *          notice, this list of conditions and the following disclaimer in the        *
! *          documentation and/or other materials provided with the distribution.       *
! *                                                                                     *
! *       3. Neither the name of the author nor the names of any contributors may       *
! *          be used to endorse or promote products derived from this software          *
! *          without specific prior written permission.                                 *
! *                                                                                     *
! *       4. If you make changes to the source code it is requested (but not required)  *
! *          that you email your changes to the address listed above so that others     *
! *          may benefit from the improvements.                                         *
! *                                                                                     *
! *      THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND ANY     *
! *      EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED      *
! *      WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE         *
! *      DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR         *
! *      ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL         *
! *      DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR     *
! *      SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER     *
! *      CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  *
! *      OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE      *
! *      USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.       *
! ***************************************************************************************

! ***************************************************************************************
! *                           THIS CODE IS A WORK-IN-PROGRESS                           *
! ***************************************************************************************

! **********                                                                   **********
! * *********************************** REQUIREMENTS! ********************************* *
! * * +-----------------------------------------------------------------------------+ * *
! * * | Windows version: Requires Windows 95 and later.                             | * *
! * * |                                                                             | * *
! * * | Files          : dated.CLW     - This file.                                 | * *
! * * |                  dated.PRJ     - Project file (or, you can make your own).  | * *
! * * |                  bgAppICON.ICO - Window icon.                               | * *
! * * +-----------------------------------------------------------------------------+ * *
! * *********************************************************************************** *
! **********                                                                   **********

! **********                                                                   **********
! * ************************************** CREDITS ************************************ *
! * * Many of the procedures presented here were derived from the work of Claus       * *
! * * Tndering in "Frequently Asked Questions about Calendars" v2.8 (2005.12.15)     * *
! * *                                                                                 * *
! * *       To obtain a copy go to: http://www.tondering.dk/claus/calendar.html       * *
! * *                                                                                 * *
! * * ------------------------------------------------------------------------------- * *
! * *                                                                                 * *
! * * Other procedures were derived from information on the SoftVelocity newsgroups   * *
! * * or were developed totally by me.                                                * *
! * *********************************************************************************** *
! **********                                                                   **********

! *********************************** Global EQUATEs: ***********************************
CRLF                                   Equate('<13,10>')             ! Carriage-Return/Line-Feed.
CRLF2                                  Equate('<13,10,13,10>')       ! Carriage-Return/Line-Feed * 2.
! Windows API equates. Only a couple of these are actually used.
DATE_LONGDATE                          Equate(00000002H)
DATE_LTRREADING                        Equate(00000010H)
DATE_RTLREADING                        Equate(00000020H)
DATE_SHORTDATE                         Equate(00000001H)
DATE_USE_ALT_CALENDAR                  Equate(00000004H)
DATE_YEARMONTH                         Equate(00000008H)
LOCALE_FONTSIGNATURE                   Equate(00000058H)
LOCALE_ICALENDARTYPE                   Equate(00001009H)
LOCALE_ICENTURY                        Equate(00000024H)
LOCALE_ICOUNTRY                        Equate(00000005H)
LOCALE_ICURRDIGITS                     Equate(00000019H)
LOCALE_ICURRENCY                       Equate(0000001bH)
LOCALE_IDATE                           Equate(00000021H)
LOCALE_IDAYLZERO                       Equate(00000026H)
LOCALE_IDEFAULTANSICODEPAGE            Equate(00001004H)
LOCALE_IDEFAULTCODEPAGE                Equate(0000000bH)
LOCALE_IDEFAULTCOUNTRY                 Equate(0000000aH)
LOCALE_IDEFAULTEBCDICCODEPAGE          Equate(00001012H)
LOCALE_IDEFAULTLANGUAGE                Equate(00000009H)
LOCALE_IDEFAULTMACCODEPAGE             Equate(00001011H)
LOCALE_IDIGITS                         Equate(00000011H)
LOCALE_IDIGITSUBSTITUTION              Equate(00001014H)
LOCALE_IFIRSTDAYOFWEEK                 Equate(0000100cH)
LOCALE_IFIRSTWEEKOFYEAR                Equate(0000100dH)
LOCALE_IINTLCURRDIGITS                 Equate(0000001aH)
LOCALE_ILANGUAGE                       Equate(00000001H)
LOCALE_ILDATE                          Equate(00000022H)
LOCALE_ILZERO                          Equate(00000012H)
LOCALE_IMEASURE                        Equate(0000000dH)
LOCALE_IMONLZERO                       Equate(00000027H)
LOCALE_INEGCURR                        Equate(0000001cH)
LOCALE_INEGNUMBER                      Equate(00001010H)
LOCALE_INEGSEPBYSPACE                  Equate(00000057H)
LOCALE_INEGSIGNPOSN                    Equate(00000053H)
LOCALE_INEGSYMPRECEDES                 Equate(00000056H)
LOCALE_IOPTIONALCALENDAR               Equate(0000100bH)
LOCALE_IPAPERSIZE                      Equate(0000100aH)
LOCALE_IPOSSEPBYSPACE                  Equate(00000055H)
LOCALE_IPOSSIGNPOSN                    Equate(00000052H)
LOCALE_IPOSSYMPRECEDES                 Equate(00000054H)
LOCALE_ITIME                           Equate(00000023H)
LOCALE_ITIMEMARKPOSN                   Equate(00001005H)
LOCALE_ITLZERO                         Equate(00000025H)
LOCALE_NOUSEROVERRIDE                  Equate(80000000H)
LOCALE_RETURN_NUMBER                   Equate(20000000H)
LOCALE_S1159                           Equate(00000028H)
LOCALE_S2359                           Equate(00000029H)
LOCALE_SABBREVCTRYNAME                 Equate(00000007H)
LOCALE_SABBREVDAYNAME1                 Equate(00000031H)
LOCALE_SABBREVDAYNAME2                 Equate(00000032H)
LOCALE_SABBREVDAYNAME3                 Equate(00000033H)
LOCALE_SABBREVDAYNAME4                 Equate(00000034H)
LOCALE_SABBREVDAYNAME5                 Equate(00000035H)
LOCALE_SABBREVDAYNAME6                 Equate(00000036H)
LOCALE_SABBREVDAYNAME7                 Equate(00000037H)
LOCALE_SABBREVLANGNAME                 Equate(00000003H)
LOCALE_SABBREVMONTHNAME1               Equate(00000044H)
LOCALE_SABBREVMONTHNAME10              Equate(0000004dH)
LOCALE_SABBREVMONTHNAME11              Equate(0000004eH)
LOCALE_SABBREVMONTHNAME12              Equate(0000004fH)
LOCALE_SABBREVMONTHNAME13              Equate(0000100fH)
LOCALE_SABBREVMONTHNAME2               Equate(00000045H)
LOCALE_SABBREVMONTHNAME3               Equate(00000046H)
LOCALE_SABBREVMONTHNAME4               Equate(00000047H)
LOCALE_SABBREVMONTHNAME5               Equate(00000048H)
LOCALE_SABBREVMONTHNAME6               Equate(00000049H)
LOCALE_SABBREVMONTHNAME7               Equate(0000004aH)
LOCALE_SABBREVMONTHNAME8               Equate(0000004bH)
LOCALE_SABBREVMONTHNAME9               Equate(0000004cH)
LOCALE_SCOUNTRY                        Equate(00000006H)
LOCALE_SCURRENCY                       Equate(00000014H)
LOCALE_SDATE                           Equate(0000001dH)
LOCALE_SDAYNAME1                       Equate(0000002aH)
LOCALE_SDAYNAME2                       Equate(0000002bH)
LOCALE_SDAYNAME3                       Equate(0000002cH)
LOCALE_SDAYNAME4                       Equate(0000002dH)
LOCALE_SDAYNAME5                       Equate(0000002eH)
LOCALE_SDAYNAME6                       Equate(0000002fH)
LOCALE_SDAYNAME7                       Equate(00000030H)
LOCALE_SDECIMAL                        Equate(0000000eH)
LOCALE_SENGCOUNTRY                     Equate(00001002H)
LOCALE_SENGCURRNAME                    Equate(00001007H)
LOCALE_SENGLANGUAGE                    Equate(00001001H)
LOCALE_SGROUPING                       Equate(00000010H)
LOCALE_SINTLSYMBOL                     Equate(00000015H)
LOCALE_SISO3166CTRYNAME                Equate(0000005aH)
LOCALE_SISO639LANGNAME                 Equate(00000059H)
LOCALE_SLANGUAGE                       Equate(00000002H)
LOCALE_SLIST                           Equate(0000000cH)
LOCALE_SLONGDATE                       Equate(00000020H)
LOCALE_SMONDECIMALSEP                  Equate(00000016H)
LOCALE_SMONGROUPING                    Equate(00000018H)
LOCALE_SMONTHNAME1                     Equate(00000038H)
LOCALE_SMONTHNAME10                    Equate(00000041H)
LOCALE_SMONTHNAME11                    Equate(00000042H)
LOCALE_SMONTHNAME12                    Equate(00000043H)
LOCALE_SMONTHNAME13                    Equate(0000100eH)
LOCALE_SMONTHNAME2                     Equate(00000039H)
LOCALE_SMONTHNAME3                     Equate(0000003aH)
LOCALE_SMONTHNAME4                     Equate(0000003bH)
LOCALE_SMONTHNAME5                     Equate(0000003cH)
LOCALE_SMONTHNAME6                     Equate(0000003dH)
LOCALE_SMONTHNAME7                     Equate(0000003eH)
LOCALE_SMONTHNAME8                     Equate(0000003fH)
LOCALE_SMONTHNAME9                     Equate(00000040H)
LOCALE_SMONTHOUSANDSEP                 Equate(00000017H)
LOCALE_SNATIVECTRYNAME                 Equate(00000008H)
LOCALE_SNATIVECURRNAME                 Equate(00001008H)
LOCALE_SNATIVEDIGITS                   Equate(00000013H)
LOCALE_SNATIVELANGNAME                 Equate(00000004H)
LOCALE_SNEGATIVESIGN                   Equate(00000051H)
LOCALE_SPOSITIVESIGN                   Equate(00000050H)
LOCALE_SSHORTDATE                      Equate(0000001fH)
LOCALE_SSORTNAME                       Equate(00001013H)
LOCALE_STHOUSAND                       Equate(0000000fH)
LOCALE_STIME                           Equate(0000001eH)
LOCALE_STIMEFORMAT                     Equate(00001003H)
LOCALE_SYEARMONTH                      Equate(00001006H)
LOCALE_USE_CP_ACP                      Equate(40000000H)
! ********************************* End Global EQUATEs: *********************************

! ****************************** Global data declarations: ******************************
! Group used to retrieve day/week number for a given year.
iwdnGroup                              Group, Type
lDay                                     Long              ! Day of date to check.
lMonth                                   Long              ! Month of date to check.
lYear                                    Long              ! Year of date to check.
lDOY                                     Long              ! On return: ordinal day of the year (lYear)
lWOY                                     Long              ! On return: week of the year (lYear)
lNewYear                                 Long              ! On return: year the week is actually in.
                                       End

loc:days                               Long                ! Day of date to check.
loc:months                             Long                ! Month of date to check.
loc:years                              Long                ! Year of date to check.
dateChanged                            Byte(1)             ! Toggle for date changes.
! **************************** End Global data declarations. ****************************

! ************************************* Global map: *************************************
  Map
    ! ***********************************************************************************
    ! * Local procedures:                                                               *
    ! ***********************************************************************************
    dayOfWeek                          (Long lD, Long lM, Long lY, Byte Style=0), String
    daysInMonth                        (Long mn, Long yr), Long
    isEasterSunday                     (Long yr, Byte Style=0), String
    isLeapYear                         (Long yr), Bool
    isMonthName                        (Long mn), String
    isWeekDayNumber                    (*iwdnGroup iGrp)
    julianDayNum                       (Long dy, Long mn, Long yr, Byte Style=0), Long

    ! ***********************************************************************************
    ! * Windows API prototypes:                                                         *
    ! ***********************************************************************************
    Module('kernel32.DLL')
      GetThreadLocale                  (), Long, Raw, Pascal, Name('GetThreadLocale'), Proc
      GetSystemDefaultLCID             (), Long, Raw, Pascal, Name('GetSystemDefaultLCID'), Proc
      GetLocaleInfo                    (                                                |
                                        Long               _Locale,                     |
                                        Long               LCType,                      |
                                        *CString           lpLCData,                    |
                                        Signed             cchData                      |
                                       ), Signed, Raw, Pascal, Name('GetLocaleInfoA'), Proc
    End ! Module('kernel32.DLL')
  End ! Map
! *********************************** End Global map. ***********************************

! ******************************* Declare our main window: ******************************
main WINDOW('Date Functions'),AT(,,482,140),FONT('Tahoma',8,,FONT:regular,CHARSET:ANSI),CENTER,IMM,TIMER(1),SYSTEM,GRAY,DOUBLE,AUTO
       GROUP(' Enter a date to check: '),AT(4,2,234,134),USE(?grpInput),BOXED
         IMAGE('calGrid.jpg'),AT(12,16),USE(?imgCalendar)
         PROMPT('Months:'),AT(142,16),USE(?loc:months:Prompt)
         LIST,AT(174,16,56,12),USE(loc:months),VSCROLL,DROP(6),FROM('January|#1|February|#2|March|#3|April|#4|May|#5|June|#6|July|#7|August|#8|September|#9|October|#10|November|#11|December|#12')
         PROMPT('Years:'),AT(142,32),USE(?loc:years:Prompt)
         SPIN(@n4),AT(174,32,40,12),USE(loc:years),RIGHT,RANGE(1582,9999)
         BUTTON('Today'),AT(142,111,88,15),USE(?btnToday)
         STRING('Day1'),AT(17,21),USE(?strDay1),TRN,CENTER
         STRING('Day2'),AT(33,21),USE(?strDay2),TRN,CENTER
         STRING('Day3'),AT(49,21),USE(?strDay3),TRN,CENTER
         STRING('Day4'),AT(67,21),USE(?strDay4),TRN,CENTER
         STRING('Day5'),AT(83,19),USE(?strDay5),TRN,CENTER
         STRING('Day6'),AT(99,21),USE(?strDay6),TRN,CENTER
         STRING('Day7'),AT(115,19),USE(?strDay7),TRN,CENTER
         OPTION(' Day: '),AT(10,10,124,120),USE(loc:days),BOXED
           RADIO('1'),AT(16,34,16,14),USE(?loc:days:Radio1),FLAT,VALUE('1')
           RADIO('2'),AT(32,34,16,14),USE(?loc:days:Radio2),FLAT,VALUE('2')
           RADIO('3'),AT(48,34,16,14),USE(?loc:days:Radio3),FLAT,VALUE('3')
           RADIO('4'),AT(64,34,16,14),USE(?loc:days:Radio4),FLAT,VALUE('4')
           RADIO('5'),AT(80,34,16,14),USE(?loc:days:Radio5),FLAT,VALUE('5')
           RADIO('6'),AT(96,34,16,14),USE(?loc:days:Radio6),FLAT,VALUE('6')
           RADIO('7'),AT(112,34,16,14),USE(?loc:days:Radio7),FLAT,VALUE('7')
           RADIO('8'),AT(16,48,16,14),USE(?loc:days:Radio8),FLAT,VALUE('8')
           RADIO('9'),AT(32,48,16,14),USE(?loc:days:Radio9),FLAT,VALUE('9')
           RADIO('10'),AT(48,48,16,14),USE(?loc:days:Radio10),FLAT,VALUE('10')
           RADIO('11'),AT(64,48,16,14),USE(?loc:days:Radio11),FLAT,VALUE('11')
           RADIO('12'),AT(80,48,16,14),USE(?loc:days:Radio12),FLAT,VALUE('12')
           RADIO('13'),AT(96,48,16,14),USE(?loc:days:Radio13),FLAT,VALUE('13')
           RADIO('14'),AT(112,48,16,14),USE(?loc:days:Radio14),FLAT,VALUE('14')
           RADIO('15'),AT(16,64,16,14),USE(?loc:days:Radio15),FLAT,VALUE('15')
           RADIO('16'),AT(32,64,16,14),USE(?loc:days:Radio16),FLAT,VALUE('16')
           RADIO('17'),AT(48,64,16,14),USE(?loc:days:Radio17),FLAT,VALUE('17')
           RADIO('18'),AT(64,64,16,14),USE(?loc:days:Radio18),FLAT,VALUE('18')
           RADIO('19'),AT(80,64,16,14),USE(?loc:days:Radio19),FLAT,VALUE('19')
           RADIO('20'),AT(96,64,16,14),USE(?loc:days:Radio20),FLAT,VALUE('20')
           RADIO('21'),AT(112,64,16,14),USE(?loc:days:Radio21),FLAT,VALUE('21')
           RADIO('22'),AT(16,78,16,14),USE(?loc:days:Radio22),FLAT,VALUE('22')
           RADIO('23'),AT(32,78,16,14),USE(?loc:days:Radio23),FLAT,VALUE('23')
           RADIO('24'),AT(48,78,16,14),USE(?loc:days:Radio24),FLAT,VALUE('24')
           RADIO('25'),AT(64,78,16,14),USE(?loc:days:Radio25),FLAT,VALUE('25')
           RADIO('26'),AT(80,78,16,14),USE(?loc:days:Radio26),FLAT,VALUE('26')
           RADIO('27'),AT(96,78,16,14),USE(?loc:days:Radio27),FLAT,VALUE('27')
           RADIO('28'),AT(112,78,16,14),USE(?loc:days:Radio28),FLAT,VALUE('28')
           RADIO('29'),AT(16,92,16,14),USE(?loc:days:Radio29),FLAT,VALUE('29')
           RADIO('30'),AT(32,92,16,14),USE(?loc:days:Radio30),FLAT,VALUE('30')
           RADIO('31'),AT(48,92,16,14),USE(?loc:days:Radio31),FLAT,VALUE('31')
         END
       END
       GROUP(' Date information: '),AT(244,2,234,134),USE(?Group2),BOXED
         PROMPT('dateInfoPrompt'),AT(252,16,218,56),USE(?dateInfoPrompt)
       END
     END
! **************************** End of main window definition: ***************************
  CODE
  System{PROP:Icon} = 'dated.EXE[0]'                       ! Set default window icon.
  Open(main)                                               ! Open the window.
  Accept                                                   ! Start checking for activity.
    Case Field()                                           ! Check which field has activity.
    Of 0                                                   ! Window level activity.
      Case Event()                                         ! Check to see which event occurred.
      Of EVENT:OpenWindow                                  ! The window is open.
        Do initWindow                                      ! Set up window.
      Of EVENT:Timer                                       ! Timer event fired.
        If dateChanged Then                                ! The date has changed.
          Do displayInfo                                   ! Redisplay information.
        End                                                ! End of If dateChanged.
      End                                                  ! End of Case Event() for window.
    Of ?btnToday                                           ! Something happened on the "Today" button.
      Case Event()                                         ! What event occurred.
      Of EVENT:Accepted                                    ! The user clicked the "Today" button.
        loc:days    = Day(Today())                         ! Reset the day to current day.
        loc:months  = Month(Today())                       ! Reset the month to current month.
        loc:years   = Year(Today())                        ! Reset the year to current year.
        dateChanged = TRUE                                 ! Toggle dateChanged.
        Select(?loc:months)                                ! Select the "Month" drop-down.
      End                                                  ! End of Case Event() for ?btnToday.
    Of ?loc:days                                           ! Something happened on the "Day" field.
      Case Event()                                         ! What event occurred.
      Of EVENT:Accepted                                    ! User reset the day.
        dateChanged = TRUE                                 ! Toggle dateChanged.
      End                                                  ! End of Case Event() for ?loc:days.
    Of ?loc:months                                         ! Something happened on the "Month" field.
      Case Event()                                         ! What event occurred.
      Of EVENT:NewSelection                                ! User changed the month.
        Do makeGrid                                        ! Reset the calendar grid.
        dateChanged = TRUE                                 ! Toggle dateChanged.
      End                                                  ! End of Case Event() for ?loc:months.
    Of ?loc:years                                          ! Something happened on the "Year" field.
      Case Event()                                         ! What event occurred.
      Of EVENT:NewSelection OrOf EVENT:Accepted            ! User changed the year.
        Do makeGrid                                        ! Reset the calendar grid.
        dateChanged = TRUE                                 ! Toggle dateChanged.
      End                                                  ! Case Event() for ?loc:years.
    End                                                    ! End of Case Event().
  End                                                      ! End of Accept loop.
  Return
! ---------------------------------------------------------------------------------------

! ---------------------------------------------------------------------------------------
initWindow                             Routine
! ---------------------------------------------------------------------------------------
  ?dateInfoPrompt{PROP:Text} = ''                          ! Clear date info prompt.
  loc:days   = Day(Today())                                ! Set to current day.
  loc:months = Month(Today())                              ! Set to current month.
  loc:years  = Year(Today())                               ! Set to current year.
  Do makeGrid                                              ! Display the calendar grid.
! ---------------------------------------------------------------------------------------

! ---------------------------------------------------------------------------------------
makeGrid                               Routine
! ---------------------------------------------------------------------------------------
  DATA
gridTop                                Long                ! Top of calendar grid.
gridLeft                               Long                ! Left of calendar grid.
gridCell                               Long, Dim(42, 4)    ! Array of calendar cells.
cellTop                                Long                ! Top of cell.
cellLeft                               Long                ! Left of cell.
cellWide                               Long(24)            ! Cell width.
cellHigh                               Long(24)            ! Cell height.
cCnt                                   Long(1)             ! Cell counter.
oCnt                                   Long                ! Outer loop counter.
iCnt                                   Long                ! Inner loop counter.
  CODE
  Do getFirstDay                                           ! Get local first day of week.
  ?loc:days{PROP:Boxed} = FALSE                            ! Turn off the calendar group box.
  main{PROP:Pixels} = TRUE                                 ! Use pixels for finer positioning.
    gridTop  = ?imgCalendar{PROP:YPos}                     ! Set the top of the calendar.
    gridLeft = ?imgCalendar{PROP:XPos}                     ! Set the left side of the calendar.
  main{PROP:Pixels} = FALSE                                ! Turn off pixels.
  cellTop  = gridTop  + 26                                 ! Set top of first cell.
  cellLeft = gridLeft + 1                                  ! Set left of first cell.
  Loop oCnt = 1 To 6                                       ! Loop thru the days.
    Loop iCnt = 1 To 7                                     ! Loop thru the weeks.
      gridCell[cCnt, 1] = cellLeft                         ! Set the left side of cell.
      gridCell[cCnt, 2] = cellTop                          ! Set the top of cell.
      gridCell[cCnt, 3] = cellWide                         ! Set the cell width.
      gridCell[cCnt, 4] = cellHigh                         ! Set the cell height.
      cellLeft += 25                                       ! Increment the left side of cell.
      cCnt += 1                                            ! Increment the cell counter.
    End                                                    ! End of Loop iCnt = 1 to 7.
    cellLeft = gridLeft + 1                                ! Set the left side of cell.
    cellTop += 25                                          ! Increment the top of cell.
  End                                                      ! End of Loop oCnt = 1 to 6.
  iCnt = 1                                                 ! Reset the counter.
  Loop oCnt = ?strDay1 To ?strDay7                         ! Loop thru the day names.
    If ~Sub(Clip(Left(dayOfWeek(1, loc:months, loc:years))), 1, 2) = oCnt{PROP:Text} Then
      iCnt += 1
    Else
      Break
    End
  End
  0{PROP:Pixels} = TRUE                                    ! Use pixels for finer positioning.
    Loop oCnt = ?loc:days:Radio1 To ?loc:days:Radio31      ! Loop thru and position the calendar days.
      SetPosition(oCnt, gridCell[iCnt, 1], gridCell[iCnt, 2], gridCell[iCnt, 3], gridCell[iCnt, 4])
      iCnt += 1
    End                                                    ! End of Loop oCnt.
  0{PROP:Pixels} = FALSE                                   ! Turn pixels off.
! ---------------------------------------------------------------------------------------

! ---------------------------------------------------------------------------------------
getFirstDay                            Routine
! ---------------------------------------------------------------------------------------
  DATA
LCID                                   Long
dName                                  CString(20)
  CODE
  ! get the system's locale ID. Where the user's locale ID is required, call GetUserLocaleLCID instead.
  LCID = GetSystemDefaultLCID()
  If GetLocaleInfo(LCID, LOCALE_IFIRSTDAYOFWEEK, dName, Size(dName)) Then
    Case dName
    Of 0                                                   ! First day of week is Monday.
      ! Set the day names.
      ?strDay1{PROP:Text}      = 'Mo'
      ?strDay2{PROP:Text}      = 'Tu'
      ?strDay3{PROP:Text}      = 'We'
      ?strDay4{PROP:Text}      = 'Th'
      ?strDay5{PROP:Text}      = 'Fr'
      ?strDay6{PROP:Text}      = 'Sa'
      ?strDay7{PROP:Text}      = 'Su'
    Of 6                                                   ! First day of week is Sunday.
      ! Set the day names.
      ?strDay1{PROP:Text}      = 'Su'
      ?strDay2{PROP:Text}      = 'Mo'
      ?strDay3{PROP:Text}      = 'Tu'
      ?strDay4{PROP:Text}      = 'We'
      ?strDay5{PROP:Text}      = 'Th'
      ?strDay6{PROP:Text}      = 'Fr'
      ?strDay7{PROP:Text}      = 'Sa'
    Else
      ! First day of week is unknown.
      Message('Unable to determine the first day of week.', 'First Day')
    End
  End
  Loop x# = ?strDay1 To ?strDay7                           ! Loop thru day names...
    ! ...and set Sunday/Saturday to COLOR:Maroon.
    If x#{PROP:Text} = 'Su' OR x#{PROP:Text} = 'Sa' Then x#{PROP:FontColor} = COLOR:Maroon.
  End                                                      ! End of Loop x#
  0{PROP:Pixels} = TRUE                                    ! Use pixels for finer positioning.
    y# = 2                                                 ! Set the x-axis position.
    Loop x# = ?strDay1 To ?strDay7                         ! Loop thru the day names.
      ! Set the position of the day names.
      SetPosition(x#, ?imgCalendar{PROP:XPos} + y#, ?imgCalendar{PROP:YPos} + ((25 - x#{PROP:Height}) / 2) + 2, 23)
      y# += 25                                             ! Increment x-axis position.
    End                                                    ! End of Loop x#
  0{PROP:Pixels} = FALSE                                   ! Turn pixels off.
! ---------------------------------------------------------------------------------------

! ---------------------------------------------------------------------------------------
displayInfo                            Routine
! ---------------------------------------------------------------------------------------
  DATA
iwdn                                   Group(iwdnGroup).   ! Group for week/day of year number.
daysInYear                             Long                ! Number of days in the year.
  CODE
  Loop x# = 1 To 12                                        ! Loop thru the months.
    daysInYear = daysInYear + daysInMonth(x#, loc:years)   ! Increment daysInYear.
  End                                                      ! End of Loop x#
  iwdn.lDay   = loc:days                                   ! Set the day to check.
  iwdn.lMonth = loc:months                                 ! Set the month to check.
  iwdn.lYear  = loc:years                                  ! Set the year to check.
  isWeekDayNumber(iwdn)                                    ! Retrieve week/day of year info.
  ! Display the information.
  ?dateInfoPrompt{PROP:Text} = 'Date<9,9>:<9>' & dayOfWeek(loc:days, loc:months, loc:years)                & ', ' &|
                               loc:days   & ' ' & isMonthName(loc:months) & ', ' & loc:years               & CRLF &|
                               'Days in month<9>:<9>'     & daysInMonth(loc:months, loc:years)             & CRLF &|
                               'Day number<9>:<9>'        & iwdn:lDOY & ' of ' & daysInYear                & CRLF &|
                               'Week number<9>:<9>'       & iwdn:lWOY & ' of ' & iwdn:lNewYear             & CRLF &|
                               'Leap year<9>:<9>'         & Choose(isLeapYear(loc:years) + 1, 'No', 'Yes') & CRLF &|
                               'Easter Sunday<9>:<9>'     & isEasterSunday(loc:years)                      & CRLF &|
                               'Julian day no.<9>:<9>'    & julianDayNum(loc:days, loc:months, loc:years)
  dateChanged = FALSE                                      ! Toggle dateChanged.
! ***************************************************************************************

! ***************************************************************************************
dayOfWeek                              Procedure(Long lD, Long lM, Long lY, Byte Style=0)
! ***************************************************************************************
! * Simple procedure to determine the day of the week for ANY day. See credits above.   *
! ***************************************************************************************
a                                      Long
y                                      Long
m                                      Long
gDOW                                   Long                ! Gregorian.
jDOW                                   Long                ! Julian.
  CODE
  a = (14 - lM) / 12
  y = lY - a
  m = lM + (12 * a) - 2

  jDOW = (5 + lD + y + Int((y / 4)) + Int((Int((31 * m)) / 12))) % 7
  gDOW = (lD + y + Int((y / 4)) - Int((y / 100)) + Int((y / 400)) + Int((Int((31 * m)) / 12))) % 7

  Case Style                                               ! Check style.
  Of 0                                                     ! Date uses Gregorian calendar.
    Return(Choose(gDOW + 1, 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'))
  Of 1                                                     ! Date uses Julian calendar.
    Return(Choose(jDOW + 1, 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'))
  Else                                                     ! Invalid style parameter..
    Message('Invalid parameter (style = ' & Style & ')', 'dayOfWeek')
    Return('***ERROR***')
  End
! ***************************************************************************************

! ***************************************************************************************
daysInMonth                            Procedure(Long mn, Long yr)
! ***************************************************************************************
!  * Simple procedure to determine the days in a given month. From the newsgroups.      *
! ***************************************************************************************
  CODE
  Case mn                                                  ! Check the month passed.
  Of 2                                                     ! February, check for leap year.
    If isLeapYear(yr) Then                                 ! Year passed is a leap year.
      Return(29)                                           ! 29 days.
    Else                                                   ! Year passed is not a leap year.
      Return(28)                                           ! 28 days.
    End                                                    ! End of If isLeapYear().
  Of 4 OrOf 6 OrOf 9 OrOf 11                               ! April, June, September & November.
     Return(30)                                            ! 30 days.
  Else                                                     ! Everything else.
     Return(31)                                            ! 31 days.
  End                                                      ! End of Case mn
! ***************************************************************************************

! ***************************************************************************************
isEasterSunday                         Procedure(Long yr, Byte Style=0)
! ***************************************************************************************
! * Simple procedure to determine when Easter Sunday occurrs. See credits above.        *
! ***************************************************************************************
G                                      Long
I                                      Long
J                                      Long
C                                      Long
H                                      Long
L                                      Long
EasterMonth                            Long
EasterDay                              Long
rVal                                   CString(20)
  CODE
  G = yr % 19
  Case Style                                               ! Gregorian.
  Of 0
    C = Int(yr / 100)
    H = (C - Int(C / 4) - Int((Int(8 * C) + 13) / 25) + Int(19 * G) + 15) % 30
    I = H - (Int(H / 28) * (1 - (Int(29 / H) + 1) * Int((21 - G) / 11)))
    J = (yr + Int(yr / 4) + I + 2 - C + Int(C / 4)) % 7
  Of 1                                                     ! Julian.
    I = ((19 * G) + 15) % 30
    J = (yr + Int(yr / 4) + I) % 7
  Else
    Message('Invalid parameter (style = ' & Style & ')', 'isEasterSunday')
    Return('***ERROR***')
  End
  L           = I - J
  EasterMonth = 3 + Int(((L + 40) / 44))
  EasterDay   = L + 28 - 31 * Int((EasterMonth / 4))
  Return(EasterDay & ' ' & isMonthName(EasterMonth))
! ***************************************************************************************

! ***************************************************************************************
isLeapYear                             Procedure(Long yr)
! ***************************************************************************************
! * Simple procedure to determine if a year is a leap year. From newsgroups.            *
! ***************************************************************************************
  CODE
  If ((yr % 4 = 0) AND (yr % 100 <> 0)) OR (yr % 400 = 0) Then Return(TRUE).
  Return(FALSE)
! ***************************************************************************************

! ***************************************************************************************
isMonthName                            Procedure(Long mn)
! ***************************************************************************************
! * Simple procedure to return the name of the month.                                   *
! ***************************************************************************************
  CODE
  Return(Choose(mn, 'January',   |
                    'February',  |
                    'March',     |
                    'April',     |
                    'May',       |
                    'June',      |
                    'July',      |
                    'August',    |
                    'September', |
                    'October',   |
                    'November',  |
                    'December'))
! ***************************************************************************************

! ***************************************************************************************
isWeekDayNumber                        Procedure(*iwdnGroup iGrp)
! ***************************************************************************************
! * Simple procedure to retrieve the day/week number for a given date. See credits above*
! ***************************************************************************************
a                                      Long
b                                      Long
c                                      Long
s                                      Long
e                                      Long
f                                      Long
g                                      Long
d                                      Long
n                                      Long
weekOfYear                             Long
dayOfYear                              Long
  CODE
  Case iGrp.lMonth
  Of 1 OrOf 2
    a = iGrp.lYear - 1
    b = Int(a / 4) - Int(a / 100) + Int(a / 400)
    c = Int((a - 1) / 4) - Int((a - 1) / 100) + Int((a - 1) / 400)
    s = b - c
    e = 0
    f = iGrp.lDay - 1 + 31 * (iGrp.lMonth - 1)
  Else
    a = iGrp.lYear
    b = Int(a / 4) - Int(a / 100) + Int(a / 400)
    c = Int((a - 1) / 4) - Int((a - 1) / 100) + Int((a - 1) / 400)
    s = b - c
    e = s + 1
    f = iGrp.lDay + Int((153 * (iGrp.lMonth - 3) + 2) / 5) + 58 + s
  End

  g = (a + b) % 7
  d = (f + g - e) % 7
  n = f + 3 - d

  If n < 0 Then
    iGrp.lWOY = 53 - Int((g - s) / 5)
    iGrp.lNewYear = iGrp.lYear - 1
  ElsIf n > (364 + s) Then
    iGrp.lWOY = 1
    iGrp.lNewYear = iGrp.lYear + 1
  Else
    iGrp.lWOY = Int(n / 7) + 1
    iGrp.lNewYear = iGrp.lYear
  End

  iGrp.lDOY = f + 1
! ***************************************************************************************

! ***************************************************************************************
julianDayNum                           Procedure(Long dy, Long mn, Long yr, Byte Style=0)
! ***************************************************************************************
! * Simple procedure to determine the Julian day number. See credits above.             *
! ***************************************************************************************
a                                      Long
y                                      Long
m                                      Long
  CODE
  a = Int((14 - mn) / 12)
  y = yr + 4800 - a
  m = mn + (12 * a) - 3

  Case Style
  Of 0                                                     ! Gregorian calendar.
    Return(dy + (Int(((153 * m) + 2) / 5)) + (365 * y) + Int((y / 4)) - Int((y / 100)) + Int((y / 400)) - 32045)
  Of 1                                                     ! Julian calendar.
    Return(dy + Int((((153 * m) + 2) / 5)) + (365 * y) + Int((y / 4)) - 32083)
  Else
    Message('Invalid parameter (style = ' & Style & ')', 'julianDayNum')
    Return(0)
  End
! ***************************************************************************************
